# Class RangingToken

java.lang.Object
com.codename1.nearby.ranging.RangingToken

public final class RangingToken extends Object

The handle one device publishes so another can range against it.

A token is opaque and platform-specific. On iOS it wraps an archived `NIDiscoveryToken`; on Android it carries the controller's UWB address, complex channel, session id and session key. There is no cross-platform UWB ranging on either OS, so a token is never portable between them -- `fromByteArray(byte[])` rejects a token minted by a different platform with a clear failure rather than handing garbage to a native call.

What the token is for is the out-of-band exchange both platforms require: prepare a session, publish `toByteArray()` over some other channel the two devices already share -- a GATT characteristic from `com.codename1.bluetooth` is the usual one -- and feed what comes back into `RangingSession.start(RangingToken)`.

    byte[] mine = session.getLocalToken().toByteArray();
    characteristic.writeValue(mine);
    // ... later, when the peer's token arrives ...
    session.start(RangingToken.fromByteArray(theirs));

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `PLATFORM_ANDROID_UWB`
  Token minted by the Android UWB stack, carrying address, channel, session id and key.
  `static final int`
  `PLATFORM_APPLE_NI`
  Token minted by Apple's Nearby Interaction, wrapping an archived `NIDiscoveryToken`.
  `static final int`
  `PLATFORM_SIMULATED`
  Token minted by the simulated implementation used on the desktop ports, the simulator and the JavaScript port.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `static RangingToken`
  `forUwbAddress(byte[] address, int channel, int preambleIndex, int sessionId, byte[] sessionKey)`
  Builds an Android-shaped token from parameters a third-party UWB accessory reported out of band.
  `static RangingToken`
  `fromByteArray(byte[] data)`
  Rebuilds a token from the bytes `toByteArray()` produced, typically after they travelled to this device over Bluetooth.
  `int`
  `getPlatform()`
  Which platform minted this token -- one of `PLATFORM_APPLE_NI`, `PLATFORM_ANDROID_UWB` or `PLATFORM_SIMULATED`.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `byte[]`
  `toByteArray()`
  The encoded form to hand to the peer.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### PLATFORM_APPLE_NI

    public static final int PLATFORM_APPLE_NI
    Token minted by Apple's Nearby Interaction, wrapping an archived `NIDiscoveryToken`.
    See Also:
      - Constant Field Values

  - ### PLATFORM_ANDROID_UWB

    public static final int PLATFORM_ANDROID_UWB
    Token minted by the Android UWB stack, carrying address, channel, session id and key.
    See Also:
      - Constant Field Values

  - ### PLATFORM_SIMULATED

    public static final int PLATFORM_SIMULATED
    Token minted by the simulated implementation used on the desktop ports, the simulator and the JavaScript port.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### forUwbAddress

    public static RangingToken forUwbAddress(byte[] address, int channel, int preambleIndex, int sessionId, byte[] sessionKey)

    Builds an Android-shaped token from parameters a third-party UWB accessory reported out of band.

    Android has no equivalent of Apple's Nearby Interaction Accessory Protocol, so an accessory there simply tells the phone which channel and session to join and the phone joins it -- that is what this builds. On iOS, use `RangingSession.startAccessory(byte[])` with the accessory's configuration data instead; a token built here is rejected there.

    ###### Parameters

    - `address`: the accessory's UWB MAC address, 2 or 8 bytes
    - `channel`: the UWB channel number
    - `preambleIndex`: the preamble index that goes with the channel
    - `sessionId`: the session id both ends agreed on
    - `sessionKey`: the session key, or `null` for an unprovisioned session

    ###### Returns

    a token that `RangingSession.start(RangingToken)` accepts on Android

  - ### fromByteArray

    public static RangingToken fromByteArray(byte[] data)

    Rebuilds a token from the bytes `toByteArray()` produced, typically after they travelled to this device over Bluetooth.

    ###### Parameters

    - `data`: the encoded token

    ###### Returns

    the decoded token

    ###### Throws

    - `IllegalArgumentException`: if the bytes are not a Codename One ranging token, or carry a version this build does not understand

  - ### toByteArray

    public byte[] toByteArray()

    The encoded form to hand to the peer. Self-describing, so the receiving side can tell a corrupt or foreign token from a usable one.

    ###### Returns

    a fresh byte array; mutating it does not affect this token

  - ### getPlatform

    public int getPlatform()
    Which platform minted this token -- one of `PLATFORM_APPLE_NI`, `PLATFORM_ANDROID_UWB` or `PLATFORM_SIMULATED`. Useful for telling the user that the device they are pointing at is the wrong kind, rather than letting the session fail with `NearbyError.INVALID_TOKEN`.

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`